﻿<?php
if (!defined('DC_RC_PATH')) { return; }

$core->tpl->addValue('EntryShortURL',array('tplShortURL','EntryShortURL'));

class tplShortURL
{
	public static function EntryShortURL($attr)
	{
		$f = $GLOBALS['core']->tpl->getFilters($attr);
		if ($GLOBALS['core']->blog->settings->shortURLEnabled) {
			return '<?php echo '.sprintf($f,'$core->blog->url.$core->url->getBase("shortURL").'.
				'"/".rawurlencode($_ctx->posts->post_id)').'; ?>';
		}
		return '';
	}
}

class shortURL extends dcUrlHandlers
{
	public static function postById($args)
	{
		$params = array('no_content' => 1,
			'post_id' => $args,
			'post_type' => '');
		$password = $GLOBALS['core']->blog->without_password;
		$GLOBALS['core']->blog->withoutPassword(false);

		// Try to find the post
		$result = $GLOBALS['core']->blog->getPosts($params);
		$GLOBALS['core']->blog->withoutPassword($password);
		if (!$result) {
			self::p404();
		}

		// Try to find the URL to go with it
		$base = $GLOBALS['core']->url->getBase($result->post_type);
		if ($base === null) {
			// try an alternate via the plural of the post_type. Works for pages.
			$base = $GLOBALS['core']->url->getBase($result->post_type.'s');
		}
		if ($base === null) {
			// could not find any suitable URL for this post-type
			self::p404();
		}

		$url = $GLOBALS['core']->blog->url.$base.'/'.$result->post_url;
		http::head(302, 'Found');
		header('Location: '.$url);
		exit;
	}
	
}
?>
